#!/usr/bin/env python
#-*- coding: iso-8859-1 -*-
###############################################################################

__all__ = [ "process_request" ]

###############################################################################

import datetime; from datetime import timedelta

def process_request(request: dict, response: dict):

    # select report data for the last hour

    period_start = request["invocation_time"] - timedelta(hours = 1)

    records = pmnc.transaction.\
        db.execute("SELECT COUNT(*) AS report FROM t WHERE tstamp >= {since}",
                   since = period_start)[0]

    # build the report (takes a single field from the first record)

    report = records[0]["report"]

    # schedule the report for guaranteed delivery

    sender = pmnc.config.get("sender")
    recipient = pmnc.config.get("recipient")
    subject = "Report for a period starting {0:s}".format(period_start.strftime("%Y-%d-%m %H"))
    message_text = "Report: {0}".format(report)

    # using retry interface's queues for this call, the call is retried at most one day

    pmnc(queue = "retry", expires_in = 86400.0).\
        email.deliver_report(sender, recipient, subject, message_text)

###############################################################################
# EOF